#Replace ${BINDIR} by the directory where you store the bash script files.
#OR simply replace path_to_your_directory by the directory
#where you store the bash script files and uncommend the following 3 lines. 
 #BINDIR=path_to_your_directory 
 #PATH=${BINDIR}:${PATH} 
 #export PATH BINDIR 
#command line parameters
	# 1. tree to run seq-gen
	tree=$1
	# 2. file to parse parameter's values for seq-gen: _phyml_stats.txt
	phymlOut=$2
	# 3. alignment to take the len
	align=$3
	# 4. begin index
	begin=$4
	# 5. end index
	end=$5
	# 6. prefix for output, default = alignment file name
	prefix=$6
if [ "$prefix" = "" ]; then prefix=$align; fi
	
scoreOut="$prefix.simCost"
#parse output from PhyML
	#nucleotide frequencies
		#base A
		fA=`cat $phymlOut | grep "f(A)=" | cut -d = -f2`; 
		#base C
		fC=`cat $phymlOut | grep "f(C)=" | cut -d = -f2`;
		#base G
		fG=`cat $phymlOut | grep "f(G)=" | cut -d = -f2`;
		#base T
		fT=`cat $phymlOut | grep "f(T)=" | cut -d = -f2`;
	#rate matrix
	AC=`cat $phymlOut | grep "A <-> C" | cut -d "C" -f2`;
	AG=`cat $phymlOut | grep "A <-> G" | cut -d "G" -f2`;
	AT=`cat $phymlOut | grep "A <-> T" | cut -d "T" -f2`;
	CG=`cat $phymlOut | grep "C <-> G" | cut -d "G" -f2`;
	CT=`cat $phymlOut | grep "C <-> T" | cut -d "T" -f2`;
	GT=`cat $phymlOut | grep "G <-> T" | cut -d "T" -f2`;

	#invariant site
	inva=`cat $phymlOut | grep "Proportion of invariant: " | cut -d : -f2`;
	
	#alpha-rate
        alpha=`cat $phymlOut | grep "Gamma shape parameter:" | cut -d : -f2`;
        cats=`cat $phymlOut | grep "Number of categories:" | cut -d : -f2`;

#get alignment length
	str=(`head -n 1 $align`)
	len=${str[1]}

for (( i=begin; i<=end; i++ )); do	
	data="$prefix.$i.gen"
	#run seq-gen
		seq-gen -z $i -mGTR -l$len -a$alpha -g$cats -i$inva -r$AC $AG $AT $CG $CT $GT -f$fA $fC $fG $fT -op <$tree >$data

	#run phyml-misfits for the generated alignment
		${BINDIR}/Unix-phyml-misfits-1.0/HKYig-phyml-misfits.sh $data

	#get result
		if [ ! -f ./$data.misfits.cost ]; then
			score=-2
		else
			if [ -f ./$data.misfits.subMorePat ]; then
				score=-2
			else
				score=`cat ./$data.misfits.cost`
			fi
		fi
	
	echo $score >> $scoreOut
#clean
	rm ./$data
	rm ./"$data".*
	rm ./"$data"_*
done	
